com.holonplatform.jpa.spring

## Interface JpaDatastoreConfigProperties

- All Superinterfaces:
    com.holonplatform.core.config.ConfigPropertySet, com.holonplatform.core.datastore.DataContextBound
  All Known Implementing Classes:
    JpaDatastoreConfigProperties.JpaDatastoreConfigPropertiesImpl

      public interface JpaDatastoreConfigProperties
      extends com.holonplatform.core.config.ConfigPropertySet, com.holonplatform.core.datastore.DataContextBound

  A `ConfigPropertySet` for JPA Datastore configuration, using `DEFAULT_NAME` as property prefix.
  Since:
    5.1.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `JpaDatastoreConfigProperties.JpaDatastoreConfigPropertiesImpl` Default implementation

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.config.ConfigPropertySet

      `com.holonplatform.core.config.ConfigPropertySet.Builder<C extends com.holonplatform.core.config.ConfigPropertySet>, com.holonplatform.core.config.ConfigPropertySet.ConfigurationException`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static com.holonplatform.core.config.ConfigProperty<Boolean>` | `AUTO_FLUSH` Whether to enable the `EntityManager` auto-flush mode.
    `static String` | `DEFAULT_NAME` Configuration property set default name
    `static com.holonplatform.core.config.ConfigProperty<Boolean>` | `PRIMARY` Whether to qualify the Datastore bean as `primary`, i.e. the preferential bean to be injected in a single-valued dependency when multiple candidates are present.
    `static com.holonplatform.core.config.ConfigProperty<Boolean>` | `TRANSACTIONAL` Whether to add `Transactional` behaviour to transactional Datastore methods, to automatically create or partecipate in a transaction when methods are invoked.

  - ### Method Summary

    All Methods Static Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `static com.holonplatform.core.config.ConfigPropertySet.Builder<JpaDatastoreConfigProperties>` | `builder()` Builder to create property set instances bound to a property data source, without data context id specification.
    `static com.holonplatform.core.config.ConfigPropertySet.Builder<JpaDatastoreConfigProperties>` | `builder(String dataContextId)` Builder to create property set instances bound to a property data source.

    - ### Methods inherited from interface com.holonplatform.core.config.ConfigPropertySet

      `getConfigPropertyName, getConfigPropertyValue, getConfigPropertyValue, getConfigPropertyValueOrElse, getName, getSubPropertiesUsingPrefix, hasConfigProperty`

    - ### Methods inherited from interface com.holonplatform.core.datastore.DataContextBound

      `getDataContextId`

- - ### Field Detail

    - #### DEFAULT_NAME

          static final String DEFAULT_NAME

      Configuration property set default name
      See Also:
        Constant Field Values

    - #### PRIMARY

          static final com.holonplatform.core.config.ConfigProperty<Boolean> PRIMARY

      Whether to qualify the Datastore bean as `primary`, i.e. the preferential bean to be injected in a single-valued dependency when multiple candidates are present.

      By default, the registred Datastore bean is marked as primary only when the `EntityManagerFactory` bean to which is bound is registered as primary candidate bean.

    - #### AUTO_FLUSH

          static final com.holonplatform.core.config.ConfigProperty<Boolean> AUTO_FLUSH

      Whether to enable the `EntityManager` auto-flush mode. When auto-flush is enabled, the `EntityManager.flush()` method is invoked after the execution of any Datastore data manipulation operation.

    - #### TRANSACTIONAL

          static final com.holonplatform.core.config.ConfigProperty<Boolean> TRANSACTIONAL

      Whether to add `Transactional` behaviour to transactional Datastore methods, to automatically create or partecipate in a transaction when methods are invoked. Affected methods are: `refresh`, `insert`, `update`, `save`, `delete`.

  - ### Method Detail

    - #### builder

          static com.holonplatform.core.config.ConfigPropertySet.Builder<JpaDatastoreConfigProperties> builder(String dataContextId)

      Builder to create property set instances bound to a property data source.
      Parameters:
        `dataContextId` - Optional data context id to which `Datastore` is bound
      Returns:
        ConfigPropertySet builder

    - #### builder

          static com.holonplatform.core.config.ConfigPropertySet.Builder<JpaDatastoreConfigProperties> builder()

      Builder to create property set instances bound to a property data source, without data context id specification.
      Returns:
        ConfigPropertySet builder

Copyright © 2019 The Holon Platform. All rights reserved.